'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _from = require('babel-runtime/core-js/array/from');

var _from2 = _interopRequireDefault(_from);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var generator = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    var _this = this;

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var result, _loop, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, id;

    return _regenerator2.default.wrap(function _callee$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (!(args.length === 0)) {
              _context2.next = 2;
              break;
            }

            throw new Error('invalid input');

          case 2:
            result = [];
            _loop = /*#__PURE__*/_regenerator2.default.mark(function _loop(id) {
              var item, songResponse, lyricResponse;
              return _regenerator2.default.wrap(function _loop$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      if (/^[0-9]*[1-9][0-9]*$/.test(id)) {
                        _context.next = 2;
                        break;
                      }

                      throw new Error('invalid song ID');

                    case 2:
                      item = {};
                      _context.next = 5;
                      return _honoka2.default.get('/song/detail/?id=' + id + '&ids=%5B' + id + '%5D');

                    case 5:
                      songResponse = _context.sent;

                      songResponse = parseResponse(songResponse);

                      if (songResponse.songs[0]) {
                        _context.next = 9;
                        break;
                      }

                      throw new Error('song ID ' + id + ' is not exist');

                    case 9:
                      songResponse = songResponse.songs[0];

                      item.title = songResponse.name;
                      item.artist = songResponse.artists.length > 1 ? joinArtists(songResponse.artists) : songResponse.artists[0].name;
                      item.cover = songResponse.album.picUrl;
                      item.src = 'https://api.kotori.love/netease/' + id + '.mp3';

                      generator.options = generator.options || {};

                      if (!generator.options.temporary) {
                        _context.next = 19;
                        break;
                      }

                      _context.next = 18;
                      return _honoka2.default.get(item.src, {
                        redirect: 'manual'
                      });

                    case 18:
                      item.src = _honoka2.default.response.headers.get('location');

                    case 19:
                      _context.next = 21;
                      return _honoka2.default.get('/song/lyric?os=pc&id=' + id + '&lv=-1&kv=-1&tv=-1');

                    case 21:
                      lyricResponse = _context.sent;

                      lyricResponse = parseResponse(lyricResponse);

                      item.lyric = lyricResponse.lrc.lyric;
                      item.translation = lyricResponse.tlyric.lyric;

                      ['lyric', 'translation'].forEach(function (key) {
                        if (item[key] === null) {
                          delete item[key];
                        }
                      });

                      result.push(item);

                    case 27:
                    case 'end':
                      return _context.stop();
                  }
                }
              }, _loop, _this);
            });
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context2.prev = 7;
            _iterator = (0, _getIterator3.default)((0, _from2.default)(args));

          case 9:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context2.next = 15;
              break;
            }

            id = _step.value;
            return _context2.delegateYield(_loop(id), 't0', 12);

          case 12:
            _iteratorNormalCompletion = true;
            _context2.next = 9;
            break;

          case 15:
            _context2.next = 21;
            break;

          case 17:
            _context2.prev = 17;
            _context2.t1 = _context2['catch'](7);
            _didIteratorError = true;
            _iteratorError = _context2.t1;

          case 21:
            _context2.prev = 21;
            _context2.prev = 22;

            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }

          case 24:
            _context2.prev = 24;

            if (!_didIteratorError) {
              _context2.next = 27;
              break;
            }

            throw _iteratorError;

          case 27:
            return _context2.finish(24);

          case 28:
            return _context2.finish(21);

          case 29:
            return _context2.abrupt('return', (0, _stringify2.default)(result, null, 2));

          case 30:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee, this, [[7, 17, 21, 29], [22,, 24, 28]]);
  }));

  return function generator() {
    return _ref.apply(this, arguments);
  };
}();

var _honoka = require('honoka');

var _honoka2 = _interopRequireDefault(_honoka);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_honoka2.default.defaults.baseURL = 'http://music.163.com/api';

function parseResponse(response) {
  try {
    response = JSON.parse(response);
  } catch (e) {
    throw new Error('response is not a valid json string');
  }

  if (response.code !== 200) {
    throw new Error('response code is not valid', response.code);
  }

  return response;
}

function joinArtists(artists) {
  return artists.map(function (artist) {
    return artist.name;
  }).join('/');
}

exports.default = generator;
module.exports = exports['default'];